# -*- coding: utf-8 -*-
import os
import sys

from kodi_six import xbmcaddon

ADDON = xbmcaddon.Addon()
ADDON_ID = ADDON.getAddonInfo("id")
ADDON_NAME = ADDON.getAddonInfo("name")
ADDON_ICON = ADDON.getAddonInfo("icon")
# BEGIN Lt2httpService-patched: globals
#ADDON_VERSION = ADDON.getAddonInfo("version")
ADDON_VERSION = ADDON.getAddonInfo('version')
GLOBALS = {}

def startApp(args):
    import six
    from kodi_six import xbmc
    dataFragment = '%00'.join(six.moves.urllib_parse.quote(arg, '') for arg in args)
    dataSuffix = '#' + dataFragment if dataFragment != '' else ''
    xbmc.executebuiltin('StartAndroidActivity(service.lt2http.android, android.intent.action.MAIN, , version:0.0.160040%s)' % dataSuffix)

def recvData(port):
    import socket
    try:
        chunks = []
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as client:
            client.connect(('127.0.0.1', port))
            while True:
                chunk = client.recv(0x2000)
                if not chunk:
                    break
                chunks.append(chunk)
        return b''.join(chunks)
    except Exception:
        pass
    return b''

def recvApp(expected, args):
    import time
    remotePort = ADDON.getSetting('remote_port')
    port = 65225
    if remotePort != '':
        port = int(remotePort)
        args.append('-localPort=' + remotePort)
    startApp(args)
    expectedB = expected.encode()
    for _ in range(100):
        data = recvData(port)
        if expectedB in data:
            return data
        time.sleep(0.1)
    return b''

def populateGlobals():
    data = recvApp('service.lt2http.android', ['-translatePath'])
    if data != b'':
        with open(os.path.join(ADDON_PATH, '.globals'), 'wb') as f:
            f.write(data)
        return True
    return False

def getGlobals():
    if GLOBALS:
        return GLOBALS
    with open(os.path.join(ADDON_PATH, '.globals'), 'r') as f:
        homeDirReplacement, xbmcDirReplacement = f.read().split('\0')
        GLOBALS['special://home'] = homeDirReplacement
        GLOBALS['special://xbmc'] = xbmcDirReplacement
    return GLOBALS

def retryStartApp():
    from lt2http.daemon import config_path, write_binary_config
    if populateGlobals():
        args = ['--config=' + config_path]
        write_binary_config()
        startApp(args)
# END Lt2httpService-patched: globals

try:
    ADDON_PATH = os.path.abspath(os.path.join(os.path.dirname(os.path.realpath(__file__).decode(sys.getfilesystemencoding(), 'ignore')), "..", "..", ".."))
except:
    ADDON_PATH = ADDON.getAddonInfo("path")
